"use strict";
/* eslint-disable functional/type-declaration-immutability */
/* eslint-disable functional/prefer-immutable-types */
Object.defineProperty(exports, "__esModule", { value: true });
exports.fpTsEffectType = exports.allEffects = exports.asynchronousEffects = exports.synchronousEffects = void 0;
const common_1 = require("./common");
// Note: `Lazy` deliberately excluded even though it has the same signature as `IO`, its semantics
// don't imply impurity like IO.
exports.synchronousEffects = [
    "IO",
    "IOEither",
    "IOOption",
];
exports.asynchronousEffects = [
    "ReaderTask",
    "ReaderTaskEither",
    "StateReaderTaskEither",
    "Task",
    "TaskEither",
    "TaskOption",
    "TaskThese",
];
exports.allEffects = exports.synchronousEffects.concat(exports.asynchronousEffects);
const fpTsEffectType = (type) => {
    const symbolName = (0, common_1.typeSymbolName)(type);
    // eslint-disable-next-line functional/no-conditional-statements
    if (symbolName === undefined || !exports.allEffects.includes(symbolName)) {
        return undefined;
    }
    const signatures = type.getCallSignatures();
    const signature = signatures[0];
    // eslint-disable-next-line functional/no-conditional-statements
    if (signatures.length !== 1 || signature === undefined) {
        return undefined;
    }
    return {
        effectType: type,
        typeParameter: signature.getReturnType(),
    };
};
exports.fpTsEffectType = fpTsEffectType;
